TelepathyQt4: MediaStreamHandlerInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

# MediaStreamHandlerInterface Class Reference
[Media stream handler proxies]

`#include <TelepathyQt4/MediaStreamHandler>`

Inherits Tp::AbstractInterface.

List of all members.

## Public Slots

- QDBusPendingReply CodecChoice (uint codecID)
- QDBusPendingReply Error (uint errorCode, const QString &message)
- QDBusPendingReply NativeCandidatesPrepared ()
- QDBusPendingReply NewActiveCandidatePair (const QString &nativeCandidateID, const QString &remoteCandidateID)
- QDBusPendingReply NewNativeCandidate (const QString &candidateID, const Tp::MediaStreamHandlerTransportList &transports)
- QDBusPendingReply Ready (const Tp::MediaStreamHandlerCodecList &codecs)
- QDBusPendingReply SetLocalCodecs (const Tp::MediaStreamHandlerCodecList &codecs)
- QDBusPendingReply StreamState (uint state)
- QDBusPendingReply SupportedCodecs (const Tp::MediaStreamHandlerCodecList &codecs)
- QDBusPendingReply CodecsUpdated (const Tp::MediaStreamHandlerCodecList &codecs)
- QDBusPendingReply HoldState (bool held)
- QDBusPendingReply UnholdFailure ()

## Signals

- void AddRemoteCandidate (const QString &candidateID, const Tp::MediaStreamHandlerTransportList &transports)
- void Close ()
- void RemoveRemoteCandidate (const QString &candidateID)
- void SetActiveCandidatePair (const QString &nativeCandidateID, const QString &remoteCandidateID)
- void SetRemoteCandidateList (const Tp::MediaStreamHandlerCandidateList &remoteCandidates)
- void SetRemoteCodecs (const Tp::MediaStreamHandlerCodecList &codecs)
- void SetStreamPlaying (bool playing)
- void SetStreamSending (bool sending)
- void StartTelephonyEvent (uchar event)
- void StopTelephonyEvent ()
- void SetStreamHeld (bool held)

## Public Member Functions

- MediaStreamHandlerInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
- MediaStreamHandlerInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
- MediaStreamHandlerInterface (Tp::DBusProxy *proxy)
- Tp::SocketAddressIPList STUNServers () const TELEPATHY_GNUC_DEPRECATED
- bool CreatedLocally () const TELEPATHY_GNUC_DEPRECATED
- QString NATTraversal () const TELEPATHY_GNUC_DEPRECATED
- Tp::StringVariantMapList RelayInfo () const TELEPATHY_GNUC_DEPRECATED

## Static Public Member Functions

- static const char * staticInterfaceName ()

## Protected Member Functions

- virtual void invalidate (Tp::DBusProxy *, const QString &, const QString &)

## Properties

- Tp::SocketAddressIPList STUNServers
- bool CreatedLocally
- QString NATTraversal
- Tp::StringVariantMapList RelayInfo

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Media.StreamHandler."

## Constructor & Destructor Documentation

MediaStreamHandlerInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a MediaStreamHandlerInterface associated with the given object on the session bus.

Parameters:

  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

MediaStreamHandlerInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0` |
| ) |  |  |

Creates a MediaStreamHandlerInterface associated with the given object on the given bus.

Parameters:

  | connection | The bus via which the object can be reached.
  | busName | Name of the service the object is on.
  | objectPath | Path to the object on the service.
  | parent | Passed to the parent class constructor.

MediaStreamHandlerInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a MediaStreamHandlerInterface associated with the same object as the given proxy.

Parameters:

  | proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static const char* staticInterfaceName | ( |  | ) | `[inline, static]`

Returns the name of the interface "org.freedesktop.Telepathy.Media.StreamHandler", which this class represents.

Returns:
  The D-Bus interface name.

Tp::SocketAddressIPList STUNServers | ( |  | ) | const`[inline]`

Getter for the remote object property "STUNServers".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

bool CreatedLocally | ( |  | ) | const`[inline]`

Getter for the remote object property "CreatedLocally".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

QString NATTraversal | ( |  | ) | const`[inline]`

Getter for the remote object property "NATTraversal".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

Tp::StringVariantMapList RelayInfo | ( |  | ) | const`[inline]`

Getter for the remote object property "RelayInfo".

Don't use this: it blocks the main loop.

Returns:
  The value of the property, or a default-constructed value if the property is not readable.

QDBusPendingReply CodecChoice | ( | uint | codecID | ) | `[inline, slot]`

Begins a call to the D-Bus method "CodecChoice" on the remote object.

Inform the connection manager of codec used to receive data.

QDBusPendingReply Error | ( | uint | errorCode,
|  | const QString & | message |
| ) |  |  | `[inline, slot]`

Begins a call to the D-Bus method "Error" on the remote object.

Inform the connection manager that an error occured in this stream. The connection manager should emit the StreamError signal for the stream on the relevant channel, and remove the stream from the session.

Parameters:

  | errorCode | ID of error, from the MediaStreamError enumeration
  | message | String describing the error

QDBusPendingReply NativeCandidatesPrepared | ( |  | ) | `[inline, slot]`

Begins a call to the D-Bus method "NativeCandidatesPrepared" on the remote object.

Informs the connection manager that all possible native candisates have been discovered for the moment.

QDBusPendingReply NewActiveCandidatePair | ( | const QString & | nativeCandidateID,
|  | const QString & | remoteCandidateID |
| ) |  |  | `[inline, slot]`

Begins a call to the D-Bus method "NewActiveCandidatePair" on the remote object.

Informs the connection manager that a valid candidate pair has been discovered and streaming is in progress.

QDBusPendingReply NewNativeCandidate | ( | const QString & | candidateID,
|  | const Tp::MediaStreamHandlerTransportList & | transports |
| ) |  |  | `[inline, slot]`

Begins a call to the D-Bus method "NewNativeCandidate" on the remote object.

Inform this MediaStreamHandler that a new native transport candidate has been ascertained.

Parameters:

  | candidateID | String identifier for this candidate
  | transports | Array of transports for this candidate, with fields: component number IP address (as a string) port base network protocol (one of the values of MediaStreamBaseProto) proto subtype (e.g. RTP) proto profile (e.g. AVP) our preference value of this transport (double in range 0.0-1.0 inclusive); 1 signals the most preferred transport transport type, one of the values of MediaStreamTransportType username if authentication is required password if authentication is required

QDBusPendingReply Ready | ( | const Tp::MediaStreamHandlerCodecList & | codecs | ) | `[inline, slot]`

Begins a call to the D-Bus method "Ready" on the remote object.

Inform the connection manager that a client is ready to handle this StreamHandler. Also provide it with info about all supported codecs.

Parameters:

  | codecs | Locally-supported codecs.

QDBusPendingReply SetLocalCodecs | ( | const Tp::MediaStreamHandlerCodecList & | codecs | ) | `[inline, slot]`

Begins a call to the D-Bus method "SetLocalCodecs" on the remote object.

Used to provide codecs after Ready(), so the media client can go ready for an incoming call and exchange candidates/codecs before knowing what local codecs are available.

This is useful for gatewaying calls between two connection managers. Given an incoming call, you need to call <tp:member-ref>Ready</tp:member-ref> to get the remote codecs before you can use them as the "local" codecs to place the outgoing call, and hence receive the outgoing call's remote codecs to use as the incoming call's "local" codecs.

In this situation, you would pass an empty list of codecs to the incoming call's Ready method, then later call SetLocalCodecs on the incoming call in order to respond to the offer.

Parameters:

  | codecs | Locally-supported codecs

QDBusPendingReply StreamState | ( | uint | state | ) | `[inline, slot]`

Begins a call to the D-Bus method "StreamState" on the remote object.

Informs the connection manager of the stream's current state, as as specified in Channel.Type.StreamedMedia::ListStreams.

QDBusPendingReply SupportedCodecs | ( | const Tp::MediaStreamHandlerCodecList & | codecs | ) | `[inline, slot]`

Begins a call to the D-Bus method "SupportedCodecs" on the remote object.

Inform the connection manager of the supported codecs for this session. This is called after the connection manager has emitted SetRemoteCodecs to notify what codecs are supported by the peer, and will thus be an intersection of all locally supported codecs (passed to Ready) and those supported by the peer.

Parameters:

  | codecs | Locally supported codecs.

QDBusPendingReply CodecsUpdated | ( | const Tp::MediaStreamHandlerCodecList & | codecs | ) | `[inline, slot]`

Begins a call to the D-Bus method "CodecsUpdated" on the remote object.

Inform the connection manager that the parameters of the supported codecs for this session have changed. The connection manager should send the new parameters to the remote contact. This is required for H.264 and Theora, for example.

Parameters:

  | codecs | Locally supported codecs, which SHOULD be the same as were previously in effect, but possibly with different parameters.

QDBusPendingReply HoldState | ( | bool | held | ) | `[inline, slot]`

Begins a call to the D-Bus method "HoldState" on the remote object.

Notify the connection manager that the stream's hold state has been changed successfully in response to SetStreamHeld.

Parameters:

  | held | If true, the stream is now on hold.

QDBusPendingReply UnholdFailure | ( |  | ) | `[inline, slot]`

Begins a call to the D-Bus method "UnholdFailure" on the remote object.

Notify the connection manager that an attempt to reacquire the necessary hardware or software resources to unhold the stream, in response to SetStreamHeld, has failed.

void AddRemoteCandidate | ( | const QString & | candidateID,
|  | const Tp::MediaStreamHandlerTransportList & | transports |
| ) |  |  | `[signal]`

Represents the signal "AddRemoteCandidate" on the remote object.

Signal emitted when the connection manager wishes to inform the client of a new remote candidate.

Parameters:

  | candidateID | String identifier for this candidate
  | transports | Array of transports for this candidate with fields, as defined in NewNativeCandidate

void Close | ( |  | ) | `[signal]`

Represents the signal "Close" on the remote object.

Signal emitted when the connection manager wishes the stream to be closed.

void RemoveRemoteCandidate | ( | const QString & | candidateID | ) | `[signal]`

Represents the signal "RemoveRemoteCandidate" on the remote object.

Signal emitted when the connection manager wishes to inform the client that the remote end has removed a previously usable candidate. It seemed like a good idea at the time, but wasn't.

Parameters:

  | candidateID | String identifier for remote candidate to drop

void SetActiveCandidatePair | ( | const QString & | nativeCandidateID,
|  | const QString & | remoteCandidateID |
| ) |  |  | `[signal]`

Represents the signal "SetActiveCandidatePair" on the remote object.

Emitted by the connection manager to inform the client that a valid candidate pair has been discovered by the remote end and streaming is in progress.

void SetRemoteCandidateList | ( | const Tp::MediaStreamHandlerCandidateList & | remoteCandidates | ) | `[signal]`

Represents the signal "SetRemoteCandidateList" on the remote object.

Signal emitted when the connection manager wishes to inform the client of all the available remote candidates at once.

Parameters:

  | remoteCandidates | A list of candidate id and a list of transports as defined in NewNativeCandidate

void SetRemoteCodecs | ( | const Tp::MediaStreamHandlerCodecList & | codecs | ) | `[signal]`

Represents the signal "SetRemoteCodecs" on the remote object.

Signal emitted when the connection manager wishes to inform the client of the codecs supported by the remote end. If these codecs are compatible with the remote codecs, then the client must call SupportedCodecs, otherwise call Error.

Parameters:

  | codecs | Codecs supported by the remote peer.

void SetStreamPlaying | ( | bool | playing | ) | `[signal]`

Represents the signal "SetStreamPlaying" on the remote object.

If emitted with argument TRUE, this means that the connection manager wishes to set the stream playing; this means that the streaming implementation should expect to receive data. If emitted with argument FALSE this signal is basically meaningless and should be ignored. We're very sorry.

void SetStreamSending | ( | bool | sending | ) | `[signal]`

Represents the signal "SetStreamSending" on the remote object.

Signal emitted when the connection manager wishes to set whether or not the stream sends to the remote end.

void StartTelephonyEvent | ( | uchar | event | ) | `[signal]`

Represents the signal "StartTelephonyEvent" on the remote object.

Request that a telephony event (as defined by RFC 4733) is transmitted over this stream until StopTelephonyEvent is called.

Parameters:

  | event | A telephony event code as defined by RFC 4733.

void StopTelephonyEvent | ( |  | ) | `[signal]`

Represents the signal "StopTelephonyEvent" on the remote object.

Request that any ongoing telephony events (as defined by RFC 4733) being transmitted over this stream are stopped.

void SetStreamHeld | ( | bool | held | ) | `[signal]`

Represents the signal "SetStreamHeld" on the remote object.

Emitted when the connection manager wishes to place the stream on hold (so the streaming client should free hardware or software resources) or take the stream off hold (so the streaming client should reacquire the necessary resources).

When placing a channel's streams on hold, the connection manager SHOULD notify the remote contact that this will be done (if appropriate in the protocol) before it emits this signal.

<tp:rationale>

It is assumed that relinquishing a resource will not fail. If it does, the call is probably doomed anyway. </tp:rationale>

When unholding a channel's streams, the connection manager SHOULD emit this signal and wait for success to be indicated via HoldState before it notifies the remote contact that the channel has been taken off hold.

<tp:rationale>

This means that if a resource is unavailable, the remote contact will never even be told that we tried to acquire it. </tp:rationale>

Parameters:

  | held | If true, the stream is to be placed on hold.

virtual void invalidate | ( | Tp::DBusProxy * | ,
|  | const QString & | ,
|  | const QString & |  |
| ) |  |  | `[protected, virtual]`

## Property Documentation

Tp::SocketAddressIPList STUNServers`[read]`

Represents property "STUNServers" on the remote object.

The IP addresses of possible STUN servers to use for NAT traversal, as dotted-quad IPv4 address literals or RFC2373 IPv6 address literals. This property cannot change once the stream has been created, so there is no change notification. The IP addresses MUST NOT be given as DNS hostnames. High-quality connection managers already need an asynchronous DNS resolver, so they might as well resolve this name to an IP to make life easier for streaming implementations.

bool CreatedLocally`[read]`

Represents property "CreatedLocally" on the remote object.

True if we were the creator of this stream, false otherwise. This information is needed for some nat traversal mechanisms, such as ICE-UDP, where the creator gets the role of the controlling agent.

QString NATTraversal`[read]`

Represents property "NATTraversal" on the remote object.

The transport (NAT traversal technique) to be used for this stream. Well-known values include:

none

  Raw UDP, with or without STUN, should be used. If the <tp:member-ref>STUNServers</tp:member-ref> property is non-empty, STUN SHOULD be used.

stun

  A deprecated synonym for 'none'.

gtalk-p2p

  Google Talk peer-to-peer connectivity establishment should be used, as implemented in libjingle 0.3.

ice-udp

  Interactive Connectivity Establishment should be used, as defined by the IETF MMUSIC working group.

wlm-8.5

  The transport used by Windows Live Messenger 8.5 or later, which resembles ICE draft 6, should be used.

wlm-2009
  The transport used by Windows Live Messenger 2009 or later, which resembles ICE draft 19, should be used.

This property cannot change once the stream has been created, so there is no change notification.

Tp::StringVariantMapList RelayInfo`[read]`

Represents property "RelayInfo" on the remote object.

A list of mappings describing TURN or Google relay servers available for the client to use in its candidate gathering, as determined from the protocol. Map keys are:

`ip` - s

  The IP address of the relay server as a dotted-quad IPv4 address literal or an RFC2373 IPv6 address literal. This MUST NOT be a DNS hostname.

  <tp:rationale> High-quality connection managers already need an asynchronous DNS resolver, so they might as well resolve this name to an IP and make life easier for streaming implementations. </tp:rationale>

`type` - s

  Either `udp` for UDP (UDP MUST be assumed if this key is omitted), `tcp` for TCP, or `tls`.

  The precise meaning of this key depends on the <tp:member-ref>NATTraversal</tp:member-ref> property: if NATTraversal is `ice-udp`, `tls` means TLS over TCP as referenced by ICE draft 19, and if NATTraversal is `gtalk-p2p`, `tls` means a fake SSL session over TCP as implemented by libjingle.

`port` - q

  The UDP or TCP port of the relay server as an ASCII unsigned integer

`username` - s

  The username to use

`password` - s

  The password to use

`component` - u

  The component number to use this relay server for, as an ASCII unsigned integer; if not included, this relay server may be used for any or all components.

  <tp:rationale> In ICE draft 6, as used by Google Talk, credentials are only valid once, so each component needs relaying separately. </tp:rationale>

<tp:rationale>

An equivalent of the gtalk-p2p-relay-token property on MediaSignalling channels is not included here. The connection manager should be responsible for making the necessary HTTP requests to turn the token into a username and password. </tp:rationale>

The type of relay server that this represents depends on the value of the <tp:member-ref>NATTraversal</tp:member-ref> property. If NATTraversal is ice-udp, this is a TURN server; if NATTraversal is gtalk-p2p, this is a Google relay server; otherwise, the meaning of RelayInfo is undefined.

If relaying is not possible for this stream, the list is empty.

This property cannot change once the stream has been created, so there is no change notification.